import { Network } from "./consts";
export declare const MAINNET_QUERY_REQUEST_PREFIX = "mainnet_query_request_000000000000|";
export declare const TESTNET_QUERY_REQUEST_PREFIX = "testnet_query_request_000000000000|";
export declare const DEVNET_QUERY_REQUEST_PREFIX = "devnet_query_request_0000000000000|";
export declare function getPrefix(network: Network): "mainnet_query_request_000000000000|" | "testnet_query_request_000000000000|" | "devnet_query_request_0000000000000|";
export declare class QueryRequest {
    nonce: number;
    requests: PerChainQueryRequest[];
    version: number;
    constructor(nonce: number, requests?: PerChainQueryRequest[], version?: number);
    serialize(): Uint8Array;
    static digest(network: Network, bytes: Uint8Array): Uint8Array;
}
export declare class PerChainQueryRequest {
    chainId: number;
    query: ChainSpecificQuery;
    constructor(chainId: number, query: ChainSpecificQuery);
    serialize(): Uint8Array;
}
export interface ChainSpecificQuery {
    type(): ChainQueryType;
    serialize(): Uint8Array;
}
export declare enum ChainQueryType {
    EthCall = 1,
    EthCallByTimeStamp = 2
}
